// Fluxions 3D Engine
// adt.hpp
// Copyright (C) 2000-2011 Jonathan Metzgar
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#ifndef FLUXIONS_ADT_HPP
#define FLUXIONS_ADT_HPP

#include <vector>

namespace Fluxions
{
	template <typename T>
	class VectorContainer
	{
	private:
		std::vector<T> list_;
	public:		
		inline void Resize(int count) {
			list_.resize(count);
		}

		inline int GetSize() const {
			return (int)list_.size();
		}

		inline bool IsEmpty() const {
			return list_.empty();
		}

		inline T & operator[](int index) {
			return list_[index];
		}

		inline const T & operator[](int index) const {
			return list_[index];
		}
	};
}

#endif
