// Fluxions 3D Engine
// bbox.hpp
// Copyright (C) 2000-2011 Jonathan Metzgar
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#ifndef FLUXIONS_BBOX_HPP
#define FLUXIONS_BBOX_HPP

#include <float.h>
#include <numeric>
#include <fluxions/ftl_math.hpp>

namespace Fluxions
{
	class BBox
	{
	public:
		BBox();
		~BBox();
		
		void Reset();
		void operator +=(const ftl::Vector3f &point);
		bool IsPointInside(const ftl::Vector3f &point) const;
		float MaxXSize() const { return max.x - min.x; }
		float MaxYSize() const { return max.y - min.y; }
		float MaxZSize() const { return max.z - min.z; }
		float MaxUniformScale() const { return ftl::max3(MaxXSize(), MaxYSize(), MaxZSize()); }
		ftl::Vector3f Center() const;
		
		ftl::Vector3f min;
		ftl::Vector3f max;
	};
}

#endif
