// Fluxions 3D Engine
// fluxions/glut_extensions.hpp
// Copyright (C) 2000-2011 Jonathan Metzgar
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

#ifndef FLUXIONS_GLUT_EXTENSIONS_HPP
#define FLUXIONS_GLUT_EXTENSIONS_HPP

#include "fluxions/opengl.hpp"

void glutWireBox(float x1, float y1, float z1, float x2, float y2, float z2);
void glutSolidBox(float x1, float y1, float z1, float x2, float y2, float z2);
void glutSolidBoxCM(float x1, float y1, float z1, float x2, float y2, float z2, bool setcolors=false);

void glutWireAxis(float size);
void glutSprite(float x1, float y1, float x2, float y2, bool flipx = false, bool flipy = false);
void glutSpriteRectangle(float x1, float y1, float x2, float y2, bool flipx = false, bool flipy = false);
void glutSpriteRectangle(float x1, float y1, float x2, float y2, float width, float height, bool flipx=false, bool flipy=false);
void glutSpriteProgram(GLuint program, float x1, float y1, float x2, float y2, bool flipx=false, bool flipy=false);
void glutSpriteProgram(GLuint program, const char *vertexAttrib, const char *texCoordAttrib, float x1, float y1, float x2, float y2, bool flipx=false, bool flipy=false);
void glutSpriteVertexArray(float x1, float y1, float x2, float y2, int vloc=-1, int tloc=-1, bool flipx=false, bool flipy=false);
void glutCheckerboard(int wsegments, int hsegments, const float *whiteColor, const float *blackColor, const float xscale, float yscale, const float xtrans, const float ytrans);
void glutCheckerboard(const float *whiteColor, const float *blackColor, const float xscale=1, float yscale=1, const float xtrans=0, const float ytrans=0);
void glutCornellBox(double scale);

void glutBitmapString(void *font, const char *string);
void glutStrokeString(void *font, const char *string);

void glutLine2(float x1, float y1, float x2, float y2);
void glutLine3(float x1, float y1, float z1, float x2, float y2, float z2);

void glutBitmapPrintRight(void *font, int y, const char *format, ...);
void glutBitmapPrintLeft(void *font, int y, const char *format, ...);
void glutBitmapPrintCenter(void *font, int y, const char *format, ...);
void glutBitmapPrint(void *font, int x, int y, const char *format, ...);
void glutStrokePrintRight(void *font, int y, const char *format, ...);
void glutStrokePrintLeft(void *font, int y, const char *format, ...);
void glutStrokePrintCenter(void *font, int y, const char *format, ...);
void glutStrokePrint(void *font, int x, int y, const char *format, ...);

void glutRenderQuickTeapot();
void glutRenderQuickOrthoRect();

#include <fluxions/ftl_math.hpp>

void gluPointLight(GLenum light, GLfloat x, GLfloat y, GLfloat z);
void gluMaterial(GLfloat *ambient, GLfloat *diffuse, GLfloat *specular);
GLuint CreateTexture();
void DeleteTexture(GLuint texID);
GLuint LoadTexture(const char *file, GLenum target=GL_TEXTURE_2D);
GLuint LoadTexture1D(const char *file);
ftl::Matrix4f GetOpenGLMatrixf(GLenum matrix);
ftl::Matrix4d GetOpenGLMatrixd(GLenum matrix);

#endif
