#ifndef FLUXIONS_OBJ_HPP
#define FLUXIONS_OBJ_HPP

#include <memory>
#include <vector>
#include <string>

#include <fluxions/ftl.hpp>

namespace Fluxions
{
	struct objFaceVertex
	{
		int vertex;
		int uv;
		int normal;

		void ReadFromString(std::string &str);
	};

	struct WavefrontModel
	{
		std::vector<ftl::Vector3f> vList;
		std::vector<ftl::Vector3f> vnList;
		std::vector<ftl::Vector2f> vtList;
		std::vector<std::vector<objFaceVertex>> faces;

		void Render();
		void RenderFace(int f);
	};

	void ReadMTL(const char *filename);
	std::shared_ptr<WavefrontModel> ReadOBJ(const char *filename);
}

#endif
