// Fluxions 3D Engine
// fluxions/opengl.hpp
// Copyright (C) 2000-2011 Jonathan Metzgar
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

#ifndef FLUXIONS_OPENGL_HPP
#define FLUXIONS_OPENGL_HPP

#include <stdlib.h>

// GLEW gets included before OpenGL
#ifdef WIN32
#include <GL/glew.h>
#endif

#ifdef APPLE
#include <GLUT/glut.h>
#else
#include <GL/freeglut.h>
#endif


//////////////////////////////////////////////////////////////////////
// C L A S S E S /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

namespace Fluxions
{


// Class GL_Viewport ///////////////////////////////////////


class GL_Viewport
{
public:
	GL_Viewport();
	~GL_Viewport();

	void SetViewport(int x, int y, int width, int height, bool applySettings = true);
	void Apply();
	void Save();
	void Restore();
	double GetAspectRatio() const { return (double)savedViewport[2] / (double)savedViewport[3]; }
	int GetX() const { return savedViewport[0]; };
	int GetY() const { return savedViewport[1]; };
	int GetWidth() const { return savedViewport[2]; };
	int GetHeight() const { return savedViewport[3]; };
private:
	GLint savedViewport[4];
};


void CALLBACK DebugMessageCallbackARB(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar *message, GLvoid *userParam);
void CALLBACK DebugMessageCallbackAMD(GLuint id, GLenum category, GLenum severity, GLsizei length, const GLchar *message, GLvoid *userParam);

} // End of Namespace Fluxions

#endif
