// Fluxions 3D Engine
// simple_scene_graph.hpp
// Copyright (C) 2000-2011 Jonathan Metzgar
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#ifndef FLUXIONS_SIMPLE_SCENE_GRAPH
#define FLUXIONS_SIMPLE_SCENE_GRAPH

#include <string>
#include <memory>
#include <fluxions/math.hpp>

namespace Fluxions
{
	namespace Scenegraph
	{
		class Node
		{
		public:
			std::string meshName;
			std::string materialName;

			Matrix4f localMatrix;
			Matrix4f worldMatrix;

			Node();
			~Node();

			std::shared_ptr<Node> parent;
			std::map<std::string> children;
		};
	}
}

#endif
