#pragma once

#include <memory>
#include <string>

namespace libmfg
{
	class object : public std::enable_shared_from_this<object>
	{
	private:
		std::string name_;
	public:
		object();
		virtual ~object();
		
		void set_name(const std::string & name);
		const std::string & get_name() const;		
	};
	
	typedef std::shared_ptr<object> object_ptr;

	template<class Ty_>
	std::shared_ptr<Ty_> create_object(std::string name)
	{
		std::shared_ptr<Ty_> new_object(new Ty_);
		new_object->set_name(name);
		return new_object;
	}
}
