#include "libmfg_random.hpp"


namespace libmfg
{
	random_number_generator::random_number_generator()
	/*
		:
	integers(0, 2147483647),
		reals(0, 1),
		smallints(0, 32767),
		smallint_generator(rng, smallints),
		int_generator(rng, integers),
		real_generator(rng, reals),
		d4_(1, 4),
		d6_(1, 6),
		d8_(1, 8),
		d10_(1, 10),
		d12_(1, 12),
		d20_(1, 20),
		d100_(1, 100),
		d4_generator(die_rng, d4_),
		d6_generator(die_rng, d6_),
		d8_generator(die_rng, d8_),
		d10_generator(die_rng, d10_),
		d12_generator(die_rng, d12_),
		d20_generator(die_rng, d20_),
		d100_generator(die_rng, d100_)
		*/
	{
	}


	random_number_generator::~random_number_generator()
	{
	}


	void random_number_generator::reset()
	{
	}


	int random_number_generator::irand()
	{
		int v = int_generator(); 
		return v < 0 ? -v : v;
	}


	int random_number_generator::small_irand()
	{
		return smallint_generator();
	}


	double random_number_generator::frand()
	{
		return real_generator();
	}


	double random_number_generator::frand(double scale)
	{
		return real_generator() * scale;
	}


	int random_number_generator::random_between(int first, int last)
	{
		if (first < last)
		{
			int tmp = first;
			first = last;
			last = tmp;
		}

		int range = last - first;
		int number = irand();
		int result = first + number % range;
		return result;
	}


	void random_number_generator::seed(int value)
	{
		rng.seed((unsigned long)value);
		die_rng.seed((unsigned long)value);
	}


	void random_number_generator::advance(int count)
	{
		while (count--)
		{
			rng();
			die_rng();
		}
	}


	int random_number_generator::d4()
	{
		return d4_generator();
	}


	int random_number_generator::d6()
	{
		return d6_generator();
	}


	int random_number_generator::d8()
	{
		return d8_generator();
	}


	int random_number_generator::d10()
	{
		return d10_generator();
	}


	int random_number_generator::d12()
	{
		return d12_generator();
	}


	int random_number_generator::d20()
	{
		return d20_generator();
	}


	int random_number_generator::d100()
	{
		return d100_generator();
	}
}
