#pragma once

#include <random>

namespace libmfg
{
	class random_number_generator
	{
	private:
		std::mt19937 rng;
		std::mt19937 die_rng;
		
		/*
		std::uniform_int<> integers;
		std::uniform_real<> reals;
		std::uniform_int<> smallints;
		std::uniform_int<> d4_, d6_, d8_, d10_, d12_, d20_, d100_;
		*/

		std::mt19937 smallint_generator;
		std::mt19937 int_generator;
		std::ranlux3_01 real_generator;
		std::mt19937 d4_generator;
		std::mt19937 d6_generator;
		std::mt19937 d8_generator;
		std::mt19937 d10_generator;
		std::mt19937 d12_generator;
		std::mt19937 d20_generator;
		std::mt19937 d100_generator;
	public:
		random_number_generator();
		~random_number_generator();
		
		void reset();
		void seed(int value=0);
		void advance(int count);
		int d4();
		int d6();
		int d8();
		int d10();
		int d12();
		int d20();
		int d100();
		int irand();
		int small_irand();
		double frand();
		double frand(double scale);
		int random_between(int first, int last);
	};
}
