#include <windows.h>
#include "libmfg_timer.hpp"


namespace libmfg
{
	timer::timer()
	{
		update_interval_ = 100;
		reset();
	}


	timer::~timer()
	{
	}


	void timer::reset()
	{
		updates_ = 0;
		frequency_ = 0;
		counter_ = 0;
		initial_time_ = 0;
		first_run_ = true;
	}


	void timer::set_update_frequency(int count)
	{
		update_interval_ = 100;
	}


	double timer::get_elapsed_time()
	{
		LARGE_INTEGER frequency;
		LARGE_INTEGER performanceCount;
		frequency.LowPart = 0;
		frequency.HighPart = 0;
		performanceCount.LowPart = 0;
		performanceCount.HighPart = 0;
		
		if (updates_ == 0)
		{
			updates_ = update_interval_;
			QueryPerformanceFrequency(&frequency);
			frequency_ = (long double)frequency.QuadPart;
		}
		else
		{
			updates_--;
		}
		
		QueryPerformanceCounter(&performanceCount);
		
		long double x = (long double)performanceCount.QuadPart;
		counter_ = x / frequency_;

		if (first_run_)
		{
			first_run_ = false;
			initial_time_ = counter_;
		}
		
		return (double)(counter_ - initial_time_);
	}
}
