#include "libmfg_tree_leaf.hpp"
#include "libmfg_tree_node.hpp"


namespace libmfg
{
	using namespace std;


	tree_leaf::tree_leaf()
	{
	}
	
	
	tree_leaf::~tree_leaf()
	{
	}
	
	
	tree_leaf_ptr tree_leaf::detach()
	{
		tree_leaf_ptr self = dynamic_pointer_cast<tree_leaf>(shared_from_this());
		tree_node_ptr parent = parent_.lock();
		
		if (parent)
		{
			parent->remove_child(self);
			parent_.reset();
		}
		
		return self;
	}
	
	
	void tree_leaf::set_parent(shared_ptr<tree_node> parent)
	{
		parent_ = parent;
	}
	
	
	tree_node_ptr tree_leaf::get_parent()
	{
		return parent_.lock();
	}
	
	
	void tree_leaf::remove_parent()
	{
		parent_.reset();
	}	
}
