#pragma once

#include "libmfg_object.hpp"

namespace libmfg
{
	class object;
	class tree_leaf;
	class tree_node;
	

	typedef std::shared_ptr<object> object_ptr;
	typedef std::shared_ptr<tree_leaf> tree_leaf_ptr;
	typedef std::shared_ptr<tree_node> tree_node_ptr;


	class tree_leaf : public object
	{
	private:
		std::weak_ptr<tree_node> parent_;
	public:
		tree_leaf();
		~tree_leaf();
		
		tree_leaf_ptr detach();
		
		void set_parent(std::shared_ptr<tree_node> parent);
		std::shared_ptr<tree_node> get_parent();
		void remove_parent();
	};
}
