#pragma once

#include "libmfg_tree_leaf.hpp"
#include <list>

namespace libmfg
{
	class tree_node : public tree_leaf
	{
	private:
		std::list<tree_leaf_ptr> children_;
	public:
		typedef std::list<tree_leaf_ptr>::iterator iterator;

		tree_node();
		~tree_node();
		
		void attach_child(tree_leaf_ptr child);
		void insert_child(tree_leaf_ptr child);
		void insert_child(int index, tree_leaf_ptr child);
		void remove_child(tree_leaf_ptr child);
		void remove_child(int index);
		int get_num_children() const;
		tree_leaf_ptr get_child(int index);
		std::list<tree_leaf_ptr>::iterator begin();
		std::list<tree_leaf_ptr>::iterator end();
		bool empty();
		bool is_child(tree_leaf_ptr child);
		bool is_child(int index);
	};
}
