#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

#include <fluxions/obj.hpp>
#include <fluxions/opengl.hpp>

namespace Fluxions
{
	using namespace std;
	using namespace ftl;

	void objFaceVertex::ReadFromString(std::string &str)
	{
		stringstream istr(str);
		char peak = 0;
		istr >> vertex >> peak;
		vertex--;
		if (peak == '/')
		{
			istr >> peak;
			if (istr && peak == '/')
			{
				uv = 0;
			}
			else
			{
				istr.putback(peak);
				istr >> uv;
				istr >> peak;
				istr >> normal;
				uv--;
				normal--;
			}
		}
		else
		{
			uv = 0;
			normal = 0;
		}
	}

	void ReadMTL(const char *filename)
	{

	}

	shared_ptr<WavefrontModel> ReadOBJ(const char *filename)
	{
		shared_ptr<WavefrontModel> model;

		ifstream fin(filename);

		if (!fin)
		{
			return model;
		}
		else
		{
			model = shared_ptr<WavefrontModel>(new WavefrontModel);
		}

		while(1)
		{
			string inputStr;
			string token;
			stringstream sstr;

			getline(fin, inputStr);
			if (!fin) break;
			sstr.str(inputStr);

			sstr >> token;
			if (token == "v")
			{
				Vector3f V;
				sstr >> V.x >> V.y >> V.z;
				model->vList.push_back(V);
			}
			else if (token == "vn")
			{
				Vector3f V;
				sstr >> V.x >> V.y >> V.z;
				model->vnList.push_back(V);
			}
			else if (token == "vt")
			{
				Vector2f V;
				sstr >> V.x >> V.y;
				model->vtList.push_back(V);
			}
			else if (token == "f")
			{
				vector<objFaceVertex> indexList;
				while (1)
				{
					string i;
					sstr >> i;
					if (!sstr)
						break;
					objFaceVertex f;
					f.ReadFromString(i);
					indexList.push_back(f);
				}
				model->faces.push_back(indexList);
			}
			else if (token == "o")
			{
			}
			else if (token == "g")
			{
			}
			else if (token == "usemtl")
			{
			}
			else if (token == "mtllib")
			{
			}
			else if (token == "s")
			{
			}
		}

		fin.close();
		return model;
	}

	void WavefrontModel::Render()
	{
		for (int f = 0; f < faces.size(); f++)
		{
			RenderFace(f);
		}
	}

	void WavefrontModel::RenderFace(int f)
	{
		glBegin(GL_POLYGON);
		for (int i = 0; i < faces[f].size(); i++)
		{
			glTexCoord2fv(vtList[faces[f][i].uv].v);
			glNormal3fv(vnList[faces[f][i].normal].v);
			glVertex3fv(vList[faces[f][i].vertex].v);
		}
		glEnd();
	}
}
