#include <iostream>
#include <string>
#include <fluxions/opengl.hpp>


using namespace std;


namespace Fluxions
{


// Class GL_Viewport ///////////////////////////////////////


GL_Viewport::GL_Viewport()
{
	savedViewport[0] = 0;
	savedViewport[1] = 0;
	savedViewport[2] = 0;
	savedViewport[3] = 0;
}


GL_Viewport::~GL_Viewport()
{
}


void GL_Viewport::SetViewport(int x, int y, int width, int height, bool applySettings)
{
	savedViewport[0] = x;
	savedViewport[1] = y;
	savedViewport[2] = width;
	savedViewport[3] = height;
	if (applySettings != false)
	{
		glViewport(savedViewport[0], savedViewport[1], savedViewport[2], savedViewport[3]);
	}
}


void GL_Viewport::Save()
{
	glGetIntegerv(GL_VIEWPORT, savedViewport);
}


void GL_Viewport::Apply()
{
	glViewport(savedViewport[0], savedViewport[1], savedViewport[2], savedViewport[3]);
}


void GL_Viewport::Restore()
{
	glViewport(savedViewport[0], savedViewport[1], savedViewport[2], savedViewport[3]);
}


// End of Class GL_Viewport ////////////////////////////////

//New Tokens
//    
//    Tokens accepted by the <target> parameters of Enable, Disable,
//    and IsEnabled:
//    
//        DEBUG_OUTPUT_SYNCHRONOUS_ARB                      0x8242
//
//    Tokens accepted by the <value> parameters of GetBooleanv,
//    GetIntegerv, GetFloatv, and GetDoublev:
//    
//        MAX_DEBUG_MESSAGE_LENGTH_ARB                      0x9143
//        MAX_DEBUG_LOGGED_MESSAGES_ARB                     0x9144
//        DEBUG_LOGGED_MESSAGES_ARB                         0x9145
//        DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_ARB              0x8243
//    
//    Tokens accepted by the <pname> parameter of GetPointerv:
//        
//        DEBUG_CALLBACK_FUNCTION_ARB                       0x8244
//        DEBUG_CALLBACK_USER_PARAM_ARB                     0x8245
//
//    Tokens accepted or provided by the <source> parameters of
//    DebugMessageControlARB, DebugMessageInsertARB and DEBUGPROCARB,
//    and the <sources> parameter of GetDebugMessageLogARB:
//        
//        DEBUG_SOURCE_API_ARB                              0x8246
//        DEBUG_SOURCE_WINDOW_SYSTEM_ARB                    0x8247
//        DEBUG_SOURCE_SHADER_COMPILER_ARB                  0x8248
//        DEBUG_SOURCE_THIRD_PARTY_ARB                      0x8249
//        DEBUG_SOURCE_APPLICATION_ARB                      0x824A
//        DEBUG_SOURCE_OTHER_ARB                            0x824B
//
//    Tokens accepted or provided by the <type> parameters of
//    DebugMessageControlARB, DebugMessageInsertARB and DEBUGPROCARB,
//    and the <types> parameter of GetDebugMessageLogARB:
//
//        DEBUG_TYPE_ERROR_ARB                              0x824C
//        DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB                0x824D
//        DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB                 0x824E
//        DEBUG_TYPE_PORTABILITY_ARB                        0x824F
//        DEBUG_TYPE_PERFORMANCE_ARB                        0x8250
//        DEBUG_TYPE_OTHER_ARB                              0x8251
//            
//    Tokens accepted or provided by the <severity> parameters of
//    DebugMessageControlARB, DebugMessageInsertARB and DEBUGPROCARB
//    callback functions, and the <severities> parameter of
//    GetDebugMessageLogARB:
//
//        DEBUG_SEVERITY_HIGH_ARB                           0x9146
//        DEBUG_SEVERITY_MEDIUM_ARB                         0x9147
//        DEBUG_SEVERITY_LOW_ARB                            0x9148
void CALLBACK DebugMessageCallbackARB(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar *message, GLvoid *userParam)
{
	string sourceString = "";
	switch (source)
	{
//        DEBUG_SOURCE_API_ARB                              0x8246
//        DEBUG_SOURCE_WINDOW_SYSTEM_ARB                    0x8247
//        DEBUG_SOURCE_SHADER_COMPILER_ARB                  0x8248
//        DEBUG_SOURCE_THIRD_PARTY_ARB                      0x8249
//        DEBUG_SOURCE_APPLICATION_ARB                      0x824A
//        DEBUG_SOURCE_OTHER_ARB                            0x824B
	case GL_DEBUG_SOURCE_API_ARB:
		sourceString = "API";
		break;
	case GL_DEBUG_SOURCE_WINDOW_SYSTEM_ARB:
		sourceString = "WINDOW SYSTEM";
		break;
	case GL_DEBUG_SOURCE_SHADER_COMPILER_ARB:
		sourceString = "SHADER COMPILER";
		break;
	case GL_DEBUG_SOURCE_THIRD_PARTY_ARB:
		sourceString = "THIRD PARTY";
		break;
	case GL_DEBUG_SOURCE_APPLICATION_ARB:
		sourceString = "APPLICATION";
		break;
	case GL_DEBUG_SOURCE_OTHER_ARB:
		sourceString = "OTHER";
		break;
	}

	string typeString = "";
	switch (type)
	{
//        DEBUG_TYPE_ERROR_ARB                              0x824C
//        DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB                0x824D
//        DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB                 0x824E
//        DEBUG_TYPE_PORTABILITY_ARB                        0x824F
//        DEBUG_TYPE_PERFORMANCE_ARB                        0x8250
//        DEBUG_TYPE_OTHER_ARB                              0x8251
	case GL_DEBUG_TYPE_ERROR_ARB:
		typeString = "ERROR";
		break;
	case GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB:
		typeString = "DEPRECATED BEHAVIOR";
		break;
	case GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB:
		typeString = "UNDEFINED BEHAVIOR";
		break;
	case GL_DEBUG_TYPE_PORTABILITY_ARB:
		typeString = "PORTABILITY";
		break;
	case GL_DEBUG_TYPE_PERFORMANCE_ARB:
		typeString = "PERFORMANCE";
		break;
	case GL_DEBUG_TYPE_OTHER_ARB:
		typeString = "OTHER";
		break;

	}

	string severityString = "";
	switch (severity)
	{
//        DEBUG_SEVERITY_HIGH_ARB                           0x9146
//        DEBUG_SEVERITY_MEDIUM_ARB                         0x9147
//        DEBUG_SEVERITY_LOW_ARB                            0x9148
	case GL_DEBUG_SEVERITY_HIGH_ARB:
		severityString = "HIGH";
		break;
	case GL_DEBUG_SEVERITY_MEDIUM_ARB:
		severityString = "MEDIUM";
		break;
	case GL_DEBUG_SEVERITY_LOW_ARB:
		severityString = "LOW";
		break;
	}
	cout << "=== ERROR_ARB ===\n";
	cout << "    source:   " << sourceString << endl;
	cout << "    type:     " << typeString << endl;
	cout << "    id:       " << id << endl;
	cout << "    severity: " << severityString << endl;
	cout << "    length:   " << length << endl;
	cout << "    message:  " << message << endl;
	cout << "--- END OF ERROR_ARB ---\n\n";
}


void CALLBACK DebugMessageCallbackAMD(GLuint id, GLenum category, GLenum severity, GLsizei length, const GLchar *message, GLvoid *userParam)
{
}


} // End of Namespace Fluxions
