#ifndef VIPERFISH_VISUALIZATION_APP_HPP
#define VIPERFISH_VISUALIZATION_APP_HPP

#include <map>
#include <string>
#include <fluxions/opengl.hpp>
#include <fluxions/ftl_math.hpp>
#include <viperfish/application.hpp>

namespace Viperfish
{
	class VisualizationApp : public Viperfish::Application
	{
	public:
		VisualizationApp();
		~VisualizationApp();

		void OnStart();
		void OnRender();
		void OnRenderOverlay();
		void OnUpdate(double deltaTime);
		void OnResize(int width, int height);
		void OnKeyDown(int key);
		void OnKeyUp(int key);
		void OnSpecialKeyDown(int key);
		void OnSpecialKeyUp(int key);
		void OnMouseMotion(int x, int y, int xrel, int yrel, int buttons);
		void OnMouseButtonDown(int button);
		void OnMouseButtonUp(int button);
	protected:
		int mouseX;
		int mouseY;
		int mouseLastX;
		int mouseLastY;
		int mouseDx;
		int mouseDy;
		unsigned mouseButtons;
		unsigned mouseLastButtons;
		int keys[256];

		int screenWidth;
		int screenHeight;
		double screenAspect;
		double fovy;
		double znear, zfar;

		int framecount;
		double elapsedTime;
		double renderTime;
		double fps;
		double dt;

		std::string applicationTitle;
		std::string copyrightStatement;

		ftl::Matrix4f projMatrix;
		ftl::Matrix4f viewMatrix;
		ftl::Matrix4f cameraMatrix;
		std::string currentObjectMatrix;
		std::map<std::string, ftl::Matrix4f> objectMatrix;
	};
}

#endif
