// ld29_warmup.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "xor_allegro.h"
#include "xor_graphics.h"
#include "xor_sound.h"
#include "commodore.h"



class MyApp1 : public Widget
{
	float x = 0;
	float y = 0;
public:
	MyApp1() { setName("MyApp1"); }

	void OnJoystickAxis(int axis, float pos)
	{
		if (axis == 0)
			x = pos;
		if (axis == 1)
			y = pos;
	}

	void OnJoystickButtonDown(int button)
	{
		if (button == 0)
			SS.PlaySample("LASER1");
	}

	void OnKeyDown(int key)
	{
		switch (key)
		{
		case ALLEGRO_KEY_1:
			age.setChild(0);
			break;
		case ALLEGRO_KEY_2:
			age.setChild(1);
			break;
		case ALLEGRO_KEY_ESCAPE:
			age.Stop();
			break;
		case ALLEGRO_KEY_3:
			SS.PlayMusic("data/music/audio_track_01.ogg");
			break;
		}
	}

	void OnRender(int pass)
	{
		if (pass == RENDER_OVERLAY)
		{
			ALLEGRO_FONT *font = age.getFont("PetMe8");
			if (font)
			{
				al_draw_text(font, al_map_rgb(255, 255, 255), 640 / 2 + x * 32, (480 / 4) + y * 32, ALLEGRO_ALIGN_CENTRE, "MyApp1!");
			}
		}
	}
};


class MyApp2 : public Widget
{
public:
	MyApp2() { setName("MyApp2"); }

	void OnKeyDown(int key)
	{
		switch (key)
		{
		case ALLEGRO_KEY_1:
			age.setChild(0);
			break;
		case ALLEGRO_KEY_2:
			age.setChild(1);
			break;
		case ALLEGRO_KEY_3:
			SS.PlaySample("LASER1");
			break;
		case ALLEGRO_KEY_4:
			SS.PlaySample("LASERGUN");
			break;
		case ALLEGRO_KEY_ESCAPE:
			age.Stop();
			break;
		}
	}

	void OnRender(int pass)
	{
		if (pass == RENDER_OVERLAY)
		{
			ALLEGRO_FONT *font = age.getFont("PetMe8");
			if (font)
			{
				al_draw_text(font, al_map_rgb(255, 255, 255), 640 / 2, (480 / 4), ALLEGRO_ALIGN_CENTRE, "MyApp2!");
			}
		}
	}
};


int main(int argc, char* argv[])
{
	MyApp1 myApp1;
	MyApp2 myApp2;

	age.children.push_back(&myApp1);
	age.children.push_back(&myApp2);
	age.setChild(0);

	age.Init(640, 400);
	age.Start();

	al_clear_to_color(al_map_rgb(0, 50, 0));

	al_flip_display();

	int color = 0;

	SS.LoadSample("LASER1", "data/sounds/LASER1.wav");
	SS.LoadSample("LASERGUN", "data/sounds/LASERGUN.wav");

	bool isRunning = true;
	while (isRunning)
	{
		isRunning = age.MainLoopIteration();

		if (age.GetElapsedTime() > 1.0)
		{
			age.ResetTimer();
			color = rand() % 31;
		}

		//al_clear_to_color(MapHexColor(VIC20_Colors[color]));
		al_clear_to_color(al_color_html(VIC20_Colors[color]));

		age.OnRender(RENDER_PASS0);
		age.OnRender(RENDER_PASS1);
		age.OnRender(RENDER_PASS2);
		age.OnRender(RENDER_PASS3);
		age.OnRender(RENDER_OVERLAY);

		al_flip_display();
	}

	return 0;
}
