#ifndef XOR_SOUND_H
#define XOR_SOUND_H

#include "xor_allegro.h"

class SoundSystem
{
private:
	ALLEGRO_VOICE *voice = NULL;
	ALLEGRO_MIXER *mixer = NULL;

	ALLEGRO_AUDIO_STREAM *audioStream = NULL;
	map<string, ALLEGRO_SAMPLE*> samples;
	vector<ALLEGRO_SAMPLE_ID> sampleIDs;
public:
	SoundSystem();
	~SoundSystem();

	void Init();
	void Kill();

	ALLEGRO_SAMPLE *FindSample(const string &name);
	void DeleteSample(const string &name);
	void LoadSample(const string &name, const string &filename);
	void PlaySample(const string &name, float gain = 1.0f, float pan = 0.0f, float speed = 1.0f, bool loop = false);
	void StopSamples();

	void PlayMusic(const string &filename);
	void StopMusic();
};


extern SoundSystem SS;

#endif
