#include "stdafx.h"
#include "xor_widget.h"


Widget *WidgetContainer::FindFirstWidget(const string &name)
{
	vector<Widget*>::iterator it;
	for (it = children.begin(); it != children.end(); it++)
	{
		if ((*it)->getName() == name)
			return *it;
	}
	return NULL;
}


void WidgetContainer::OnInit()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnInit();
		}
	});
}


void WidgetContainer::OnKill()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnKill();
		}
	});
}


void WidgetContainer::OnStart()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnStart();
		}
	});
}


void WidgetContainer::OnStop()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnStop();
		}
	});
}


void WidgetContainer::OnPause()
{

	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnPause();
		}
	});
}


void WidgetContainer::OnResume()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnResume();
		}
	});
}


void WidgetContainer::OnIdle(double deltaTime)
{
	for_each(children.begin(), children.end(), [deltaTime](Widget *child) {
		if (child != NULL)
		{
			child->OnIdle(deltaTime);
		}
	});
}


void WidgetContainer::OnIdleForeground(double deltaTime)
{
	for_each(children.begin(), children.end(), [deltaTime](Widget *child) {
		if (child != NULL)
		{
			child->OnIdleForeground(deltaTime);
		}
	});
}


void WidgetContainer::OnEnterForeground()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnEnterForeground();
		}
	});
}


void WidgetContainer::OnLeaveForeground()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnLeaveForeground();
		}
	});
}


void WidgetContainer::OnIdleBackground(double deltaTime)
{
	for_each(children.begin(), children.end(), [deltaTime](Widget *child) {
		if (child != NULL)
		{
			child->OnIdleBackground(deltaTime);
		}
	});
}


void WidgetContainer::OnEnterBackground()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnEnterBackground();
		}
	});
}


void WidgetContainer::OnLeaveBackground()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnLeaveBackground();
		}
	});
}


void WidgetContainer::OnEnterSuspended()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnEnterSuspended();
		}
	});
}


void WidgetContainer::OnLeaveSuspended()
{
	for_each(children.begin(), children.end(), [](Widget *child) {
		if (child != NULL)
		{
			child->OnLeaveSuspended();
		}
	});
}


void WidgetContainer::OnJoystickAxis(int axis, float value)
{
	for_each(children.begin(), children.end(), [axis, value](Widget *child) {
		if (child != NULL)
		{
			child->OnJoystickAxis(axis, value);
		}
	});
}


void WidgetContainer::OnJoystickButtonDown(int button)
{
	for_each(children.begin(), children.end(), [button](Widget *child) {
		if (child != NULL)
		{
			child->OnJoystickButtonDown(button);
		}
	});
}


void WidgetContainer::OnJoystickButtonUp(int button)
{
	for_each(children.begin(), children.end(), [button](Widget *child) {
		if (child != NULL)
		{
			child->OnJoystickButtonUp(button);
		}
	});
}


void WidgetContainer::OnKeyDown(int key)
{
	for_each(children.begin(), children.end(), [key](Widget *child) {
		if (child != NULL)
		{
			child->OnKeyDown(key);
		}
	});
}


void WidgetContainer::OnKeyUp(int key)
{
	for_each(children.begin(), children.end(), [key](Widget *child) {
		if (child != NULL)
		{
			child->OnKeyUp(key);
		}
	});
}


void WidgetContainer::OnKeyChar(int unicode)
{
	for_each(children.begin(), children.end(), [unicode](Widget *child) {
		if (child != NULL)
		{
			child->OnKeyChar(unicode);
		}
	});
}


void WidgetContainer::OnMouseMotion(int x, int y, int dx, int dy)
{
	for_each(children.begin(), children.end(), [x, y, dx, dy](Widget *child) {
		if (child != NULL)
		{
			child->OnMouseMotion(x, y, dx, dy);
		}
	});
}


void WidgetContainer::OnMouseButtonDown(int x, int y, int button)
{
	for_each(children.begin(), children.end(), [x, y, button](Widget *child) {
		if (child != NULL)
		{
			child->OnMouseButtonDown(x, y, button);
		}
	});
}


void WidgetContainer::OnMouseButtonUp(int x, int y, int button)
{
	for_each(children.begin(), children.end(), [x, y, button](Widget *child) {
		if (child != NULL)
		{
			child->OnMouseButtonUp(x, y, button);
		}
	});
}


void WidgetContainer::OnDisplayResize(int width, int height)
{
	for_each(children.begin(), children.end(), [width, height](Widget *child) {
		if (child != NULL)
		{
			child->OnDisplayResize(width, height);
		}
	});
}


void WidgetContainer::OnRender(int pass)
{
	for_each(children.begin(), children.end(), [pass](Widget *child) {
		if (child != NULL)
		{
			child->OnRender(pass);
		}
	});
}


void WidgetSwitch::OnInit()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnInit();
	}
}


void WidgetSwitch::OnKill()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnKill();
	}
}


void WidgetSwitch::OnStart()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnStart();
	}
}


void WidgetSwitch::OnStop()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnStop();
	}
}


void WidgetSwitch::OnPause()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnPause();
	}
}


void WidgetSwitch::OnResume()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnResume();
	}
}


void WidgetSwitch::OnIdle(double deltaTime)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnIdle(deltaTime);
	}
}


void WidgetSwitch::OnIdleForeground(double deltaTime)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnIdleForeground(deltaTime);
	}
}


void WidgetSwitch::OnEnterForeground()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnEnterForeground();
	}
}


void WidgetSwitch::OnLeaveForeground()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnLeaveForeground();
	}
}


void WidgetSwitch::OnIdleBackground(double deltaTime)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnIdleBackground(deltaTime);
	}
}


void WidgetSwitch::OnEnterBackground()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnEnterBackground();
	}
}


void WidgetSwitch::OnLeaveBackground()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnLeaveBackground();
	}
}


void WidgetSwitch::OnEnterSuspended()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnEnterSuspended();
	}
}


void WidgetSwitch::OnLeaveSuspended()
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnLeaveSuspended();
	}
}


void WidgetSwitch::OnJoystickAxis(int axis, float value)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnJoystickAxis(axis, value);
	}
}


void WidgetSwitch::OnJoystickButtonDown(int button)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnJoystickButtonDown(button);
	}
}


void WidgetSwitch::OnJoystickButtonUp(int button)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnJoystickButtonUp(button);
	}
}


void WidgetSwitch::OnKeyDown(int key)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnKeyDown(key);
	}
}


void WidgetSwitch::OnKeyUp(int key)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnKeyUp(key);
	}
}


void WidgetSwitch::OnKeyChar(int unicode)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnKeyChar(unicode);
	}
}


void WidgetSwitch::OnMouseMotion(int x, int y, int dx, int dy)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnMouseMotion(x, y, dx, dy);
	}
}


void WidgetSwitch::OnMouseButtonDown(int x, int y, int button)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnMouseButtonDown(x, y, button);
	}
}


void WidgetSwitch::OnMouseButtonUp(int x, int y, int button)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnMouseButtonUp(x, y, button);
	}
}


void WidgetSwitch::OnDisplayResize(int width, int height)
{
	Widget *child = getSelected();
	if (child != NULL)
	{
		child->OnDisplayResize(width, height);
	}
}


void WidgetSwitch::OnRender(int pass)
{
	if (actLikeContainer)
	{
		WidgetContainer::OnRender(pass);
	}
	else
	{
		Widget *child = getSelected();
		if (child != NULL)
		{
			child->OnRender(pass);
		}
	}
}


